unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Licz: TButton;
    Dane: TEdit;
    Slowa: TMemo;
    Opis: TRichEdit;
    procedure Button1Click(Sender: TObject);
    procedure LiczClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// Wersja z licznikiem
procedure PrzetworzSlowo0 (Slowo: string; var Wynik: TMemo);
var
  IleBledow : integer;
  i         : integer;
begin
 IleBledow := 0;
 for i:=1 to Length(Slowo) - 1 do
   if (Slowo[i] in ['0'..'9']) and not (Slowo[i+1] in ['a'..'z'])
   then
     IleBledow := IleBledow + 1;
 if Slowo[Length(Slowo)] in ['0'..'9']
 then
    IleBledow := IleBledow + 1;
 if IleBledow = 0
 then
  Wynik.lines.Add(Slowo)
end; {PrzetwrzSowo0}

// Wersja ze zmienn logiczn
procedure PrzetworzSlowo1 (Slowo: string; var Wynik: TMemo);
var
  Pasuje : boolean;
  i      : integer;
begin
 Pasuje := true;
 for i:=1 to Length(Slowo) - 1 do
   if Slowo[i] in ['0'..'9']
   then
     Pasuje := (Slowo[i+1] in ['a'..'z']) and Pasuje;
 if Slowo[length(Slowo)] in ['0'..'9']
 then
    Pasuje := false;
 if Pasuje
 then
  Wynik.lines.Add(Slowo)
end; {PrzetwrzSowo1}

// Mona si pozby ifa z ptli
procedure PrzetworzSlowo2 (Slowo: string; var Wynik: TMemo);
var
  Pasuje : boolean;
  i      : integer;
begin
 Pasuje := true;
 for i:=1 to Length(Slowo) - 1 do
   Pasuje := ((not (Slowo[i] in ['0'..'9']) or (Slowo[i+1] in ['a'..'z']))) and Pasuje;
 if Slowo[length(Slowo)] in ['0'..'9']
 then
    Pasuje := false;
 if Pasuje
 then
  Wynik.lines.Add(Slowo)
end; {PrzetwrzSowo2}

// Wersja w ptl for po caej dugoci sowa
procedure PrzetworzSlowo3 (Slowo: string; var Wynik: TMemo);
var
  Pasuje : boolean;
  i      : integer;
begin
 Pasuje := true;
 for i:=1 to Length(Slowo) do
   if Slowo[i] in ['0'..'9']
   then
    if i < Length(Slowo)
    then
      Pasuje := (Slowo[i+1] in ['a'..'z']) and Pasuje
    else
      Pasuje := false;
 if Pasuje
 then
  Wynik.lines.Add(Slowo)
end; {PrzetwrzSowo3}

// I jeszcze wersja z while
procedure PrzetworzSlowo4 (Slowo: string; var Wynik: TMemo);
var
  Pasuje : boolean;
  i      : integer;
begin
 Pasuje := true;
 i := 1;
 while Pasuje and (i <= Length(Slowo)) do
  begin
   if Slowo[i] in ['0'..'9']
   then
     Pasuje := (i<length(Slowo)) and (Slowo[i+1] in ['a'..'z']);
   i := i + 1;
  end; // while
 if Pasuje
 then
  Wynik.lines.Add(Slowo)
end; {PrzetwrzSowo4}

procedure PrzetworzWiersz(Wiersz: string; var Wynik: TMemo);
 var
  i     : integer;
  slowo : string;
begin
 Slowo := '';
 for i:= 1 to Length(Wiersz) do
  begin
   if Wiersz[i] = ' '
   then
    begin
     if slowo <> ''
     then
      PrzetworzSlowo0(Slowo, Wynik);
     Slowo := ''
    end
   else
    Slowo := Slowo + wiersz[i]
  end; // for
 if Slowo <> ''
 then
  PrzetworzSlowo0(Slowo, Wynik)
end; {PrzetwrzWiersz}

procedure TForm1.Button1Click(Sender: TObject);
begin
 Close
end;

procedure TForm1.LiczClick(Sender: TObject);
begin
 Slowa.Clear;
 PrzetworzWiersz(Dane.Text, Slowa);
end;

end.
